<template>
    <div class="page-table scrollable only-y" id="affix-container">
        <div class="">
            <h1>Account
            </h1>
            <!--<h4>for a better experience on Mac OS during horizontal scroll is prefered disable the "Swipe between pages" option </h4>-->
            <div class="page-status">

                <el-breadcrumb separator="/">
                    <el-breadcrumb-item :to="{ path: '/' }"><i class="mdi mdi-home-outline"></i></el-breadcrumb-item>
                    <el-breadcrumb-item :to="{ path: '/accounts' }">Account</el-breadcrumb-item>
                    <el-breadcrumb-item :to="{ path: '/accounts/' + $route.params.id}">{{this.name.length  < 50 ? this.name : this.name.substring(0,45)+'...'}}</el-breadcrumb-item>
                    <el-breadcrumb-item>Edit</el-breadcrumb-item>


                </el-breadcrumb>
            </div>
        </div>
        <br/>
        <el-card v-if="isContentFound"   v-loading="loading">
            <not-found></not-found>
        </el-card>
        <div v-else>
            <el-card class="box-card"  v-loading="loading">
                <div class="card-inner" v-if="detail">
                    <div class="line">
                        <div class="">

                        </div>
                    </div>

                    <div class="form-box" style="margin-top: 20px" @keyup.enter="save">
                        <el-form :rules="rules" ref="detail" :model="detail" class="form-edit-account">
                            <el-row :gutter="30">
                                <el-col :span="24" :md="24" :sm="24" :xs="24" class="col-p">
                                    <el-form-item label="Account Name" prop="name">
                                        <el-input v-model="detail.name" />
                                    </el-form-item>
                                </el-col>

                            </el-row>
                            <el-row :gutter="30">
                                <el-col :span="24" :md="24" :sm="24" :xs="24" class="col-p">
                                    <el-form-item label="User Role" prop="selectedRole">
                                        <br/>
                                        <el-select v-model="detail.selectedRole" placeholder="Select user role">
                                            <el-option v-for="item in roleList"
                                                        :key="item.id"
                                                       :label="item.name"
                                                       :value="item.id">
                                            </el-option>
                                        </el-select>
                                    </el-form-item>
                                </el-col>

                            </el-row>
                            <el-row :gutter="30">
                                  <el-col :span="24" :md="24" :sm="24" :xs="24" class="col-p">
                                    <el-form-item label="Password" prop="pass">
                                        <!--<el-input  type="text" v-model="address" @focus="openDialog"/>-->
                                        <el-input  type="password" v-model="detail.pass" />
                                    </el-form-item>
                                </el-col>
                            </el-row>
                            <el-row :gutter="30">
                                <el-col :span="24" :md="24" :sm="24" :xs="24" class="col-p">
                                    <el-form-item  label="Confirm Password" prop="checkPass">
                                        <el-input type="password" v-model="detail.checkPass"></el-input>
                                    </el-form-item>
                                </el-col>
                            </el-row>
                            <div >
                                <div class="btn-right ">
                                    <el-button icon="mdi mdi-content-save-outline"
                                               type="primary"
                                               @click="save"
                                               class="mb-20"
                                               @keyup.enter="save">
                                        Save changes
                                    </el-button>
                                </div>
                            </div>
                        </el-form>
                    </div>
                </div>
            </el-card>
           <!---->
            <!--<view-image-->
                    <!--:dialogvisible.sync="dialogvisible"-->
                    <!--:imageUrl.sync="imageUrl">-->
            <!--</view-image>-->
        </div>

    </div>
</template>

<script>

    import ViewImage from "~/components/dialogs/ViewImage";
    import {
        account as accountAPI,
        role as roleAPI
    } from '~/services/apis/index';
    import NotFound from '../ContentNotFound'
    export default {
        name: 'AccountEdit',
        components: {
            NotFound,
            ViewImage
        },
        data() {
                let validatePass = (rule, value, callback) => {
                    if(!value) {
                        callback();
                    } else {
                         if(value.length < 6) {
                callback(new Error('The password must be greater than 6 character'));
                }
                else {
                    if (this.detail.checkPass !== '') {
                        this.$refs.detail.validateField('checkPass');
                    }
                callback();
                }
                    }

            };
            let validatePass2 = (rule, value, callback) => {
                if(!value) {
                    callback();
                } else {
                      if(value.length < 6) {
                callback(new Error('The password must be greater than 6 character'));
                }
                else if (value !== this.detail.pass) {
                callback(new Error("Confirmed password didn't match!"));
                } else {
                callback();
                }
                }

            };
            return {
                detail: {
                    id: '',
                    name: '',
                    username: '',
                    created_at: "",
                    updated_at: "",
                    pass: '',
                    checkPass: '',
                    selectedRole: "",
                },
                name: '',
                loading: true,
                isContentFound: false,
                isDisabledSave: false,
                rules: {
                    name: [
                        { required: true, message: 'Please input account name', trigger: 'blur' },
                        { max: 255, message: 'Length must be less than 256', trigger: 'blur' }
                    ],
                    pass: [
                            { validator: validatePass, trigger: 'blur' }
                        ],
                    checkPass: [
                         { validator: validatePass2, trigger: 'blur' }
                    ],
                    selectedRole: [
                        {required: true, message: 'Please select a role', trigger: 'blur' }
                    ],
                },
                roleList: [],
            }
        },
        methods: {
            getDetail(){
                if(!this.$route || !this.$route.params.id) return;
                accountAPI.getAccount(this.$route.params.id)
                .then((res) => {
                    this.initDetail(res.data.data);
                    this.isContentFound = false;
                    this.loading = false;
                })
                .catch((err) => {
                    this.isContentFound = true;
                    this.loading = false;
                })
            },
            initDetail(data){
                if(!data) return;

                this.detail.id = data.id;
                this.detail.name = data.name;
                this.detail.username = data.username;
                this.detail.created_at = data.created_at;
                this.detail.updated_at = data.updated_at;

                this.name = data.name;
                this.detail.selectedRole = data.roles.length ? data.roles[0].id : "";
            },
            showAvatar(url,event) {
                if (event) {
                    event.preventDefault();
                    event.stopPropagation();
                }

                if(!url) return;
                this.imageUrl = url;
                this.dialogvisible = true;
            },
            save(){
                this.loading = true;
                this.$refs['detail'].validate((valid) => {
                    if (valid) {
                        this.submit();
                    } else {
                        this.loading = false;
                        return false;
                    }
                });

            },
            submit(){
                let data = {};
                if(!this.detail.pass) {
                    data = {
                         name: this.detail.name,
                    };
                } else {
                     data = {
                        name: this.detail.name,
                        password: this.detail.pass
                };
                }

                this.detail.selectedRole? data.role_id = this.detail.selectedRole : "";

                accountAPI.updateAccount(this.$route.params.id, data)
                    .then((res)=>{
                        this.$notify({
                            title: "Success",
                            message: "Update successfully!",
                            type: "success"
                        });
                        this.loading = false;
                        this.$router.push({name: 'account_detail'});
                    })
                    .catch((err)=>{
                        this.$notify({
                            title: "Error",
                            message: "Update failed!",
                            type: "error"
                        });
                        this.loading = false;
                    })
            },
            getRoleList(){
                roleAPI.getRoles()
                    .then((res)=>{
                        this.roleList = res.data.data;
                    })
            }

        },

        mounted(){
            this.getDetail();
            this.getRoleList();
        }
    }
</script>

<style lang="scss">
    .form-edit-account{
        .el-select{
            width: 100%;
        }
    }
